#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <fstream>
#define eps 1e-9

using namespace std;

double diff;
int cmpDouble(double x, double y) {
    diff = x - y;
    if(diff < -eps) return -1;
    if(diff > eps) return 1;
    return 0;
    }

struct data {
    int r, c;
    int k, t;
    int realn;
    char f[10][10];
    } t[100];
bool cmp1(data a, data b) { if(a.k != b.k) return a.k < b.k; return a.t > b.t; }
bool cmp2(data a, data b) { if(a.t != b.t) return a.t > b.t; return a.k < b.k; }

int n, m, p;
double a[50][50];

int i1, j1, ib, jb;
double cur;
double l;

bool check(int i, int j, int ind) {
    i1 = i + t[ind].r, j1 = j + t[ind].c,
    ib = i, jb = j,
    cur = 0.00,
    l = double(t[ind].t);

    for(i=ib; i<i1; i++)
    for(j=jb; j<j1; j++)
    if(t[ind].f[i-ib][j-jb] == '1')
        if(cmpDouble(a[i][j], l) > -1) cur += a[i][j];
        else return 0;

    return 1;
    }

double k;
void upd(int i, int j, int ind) {
    i1 = i + t[ind].r, j1 = j + t[ind].c,
    ib = i, jb = j,
    k = double(t[ind].k);

    for(i=ib; i<i1; i++)
    for(j=jb; j<j1; j++)
    if(t[ind].f[i-ib][j-jb] == '1')
        a[i][j] /= k;
    }

void restore(int i, int j, int ind) {
    i1 = i + t[ind].r, j1 = j + t[ind].c,
    ib = i, jb = j,
    k = double(t[ind].k);

    for(i=ib; i<i1; i++)
    for(j=jb; j<j1; j++)
    if(t[ind].f[i-ib][j-jb] == '1')
        a[i][j] *= k;
    }

int sz[4];
struct answer {
    int i, j, ind;
    answer() {};
    answer(int _i,int _j,int _ind) : i(_i), j(_j), ind(_ind) {};
    } ans[4][100], tek[100];

int nmb;
double answ[4];
double best;

void fnd(int ind) {
    best = 0.00;

    int r = t[ind].r, c = t[ind].c;
    int i, j;
    int i1, j1;

    for(i=0; i<=n-r; i++)
    for(j=0; j<=m-c; j++)
    if(check(i, j, ind))
        if(cmpDouble(cur, best) == 1)
            best = cur,
            i1 = i, j1 = j;

    if(cmpDouble(best, 0.00) == 1)
              answ[nmb] += best,
              upd(i1, j1, ind),
              ans[nmb][sz[nmb]] = answer(i1, j1, t[ind].realn),
              sz[nmb]++;
    }

double a_c[50][50];

void solve() {
    for(int i=0; i<p; i++) fnd(i);
    }

double cur_n;
int siz;
int fix;

void solve2(int ind) {
    if(ind == p) {
        fix--;
        if(cmpDouble(cur_n, best) == 1) {
                best = cur_n,
                answ[nmb] = best,
                sz[nmb] = siz;
                for(int i=0; i<siz; i++) ans[nmb][i] = tek[i];
                }
        return;
        }

    int i, j;
    int r = t[ind].r, c = t[ind].c;
    double curi;

    for(i=0; i<=n-r; i++)
    for(j=0; j<=m-c; j++)
    if(check(i, j, ind))
        {
        tek[siz] = answer(i, j, t[ind].realn),

        upd(i, j, ind),
        curi = cur,

        cur_n += curi, siz++,
        solve2(ind + 1);

        if(fix == 0) return;

        cur_n -= curi, siz--,
        restore(i, j, ind);
        }

    solve2(ind + 1);
    }

int main() {
    FILE *win;
    FILE *wout;

    win = fopen("parash.in", "r");
    wout = fopen("parash.out", "w");

    fscanf(win, "%d%d%d", &n, &m, &p);

    int i, j;

    for(i=0; i<n; i++)
    for(j=0; j<m; j++)
    fscanf(win, "%lf", &a[i][j]),
    a_c[i][j] = a[i][j];

    for(i=0; i<p; i++) {
        t[i].realn = i;
        fscanf(win, "%d%d%d%d", &t[i].r, &t[i].c, &t[i].k, &t[i].t);
        for(j=0; j<t[i].r; j++) fscanf(win, "%s", &t[i].f[j]);
        }

    memcpy(a, a_c, sizeof(double) * 50 * 50);
    sort(t, t+p, cmp1);
    solve();

    memcpy(a, a_c, sizeof(double) * 50 * 50);
    nmb = 1;
    sort(t, t+p, cmp2);
    solve();

    memcpy(a, a_c, sizeof(double) * 50 * 50);
    //sort(t, t+p, cmp1);
    best = 0.00,
    fix = 5000,
    nmb = 2,
    solve2(0);

    int an = 0;
    if(cmpDouble(answ[an], answ[1]) == -1) an = 1;
    if(cmpDouble(answ[an], answ[2]) == -1) an = 2;

    //print
    fprintf(wout, "%d\n", sz[an]);
    for(i=0; i<sz[an]; i++)
        fprintf(wout, "%d %d %d\n", ans[an][i].ind + 1, ans[an][i].i + 1, ans[an][i].j + 1);

    return 0;
    }
